unit SjrdAbout platform;

interface

{$I SJRDComps.inc}

uses
{$IFDEF SJRD_WINDOWS}
  Forms, Graphics, StdCtrls, ExtCtrls, Controls,
{$ENDIF}
{$IFDEF SJRD_LINUX}
  QForms, QGraphics, QStdCtrls, QExtCtrls, QControls,
{$ENDIF}
  SjrdLabels, Classes;

type
  TSjrdAboutForm = class(TForm)
    ImageProgramIcon: TImage;
    LabelProgramName: TLabel;
    LabelProgramVersion: TLabel;
    LabelAuthor: TLabel;
    LabelContactAuthor: TSjrdURLLabel;
    LabelWebSite: TSjrdURLLabel;
    ButtonOK: TButton;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    class procedure ShowAbout(Title : string; ProgramIcon : TGraphic;
                              ProgramName : string; ProgramVersion : string;
                              Author : string; AuthorEMail : string = '';
                              WebSite : string = '');
  end;

implementation

{$R *.dfm}

/////////////////////////////
/// Classe TSjrdAboutForm ///
/////////////////////////////

class procedure TSjrdAboutForm.ShowAbout(Title : string; ProgramIcon : TGraphic;
                                         ProgramName : string; ProgramVersion : string;
                                         Author : string; AuthorEMail : string;
                                         WebSite : string);
var I : integer;
begin
  with Create(nil) do
  try
    Caption := Title;
    ImageProgramIcon.Picture.Assign(ProgramIcon);
    LabelProgramName.Caption := ProgramName;
    LabelProgramVersion.Caption := ProgramVersion;
    LabelAuthor.Caption := Author;
    if AuthorEMail = '' then LabelContactAuthor.Visible := False else
    begin
      if Pos('?', AuthorEMail) = 0 then
        LabelContactAuthor.Caption := AuthorEMail
      else
        LabelContactAuthor.Caption := Copy(AuthorEMail, 1, Pos('?', AuthorEMail)-1);
      LabelContactAuthor.URL := 'mailto:'+AuthorEMail;
    end;
    if WebSite = '' then LabelWebSite.Visible := False else
    begin
      I := Pos('://', WebSite);
      if I = 0 then LabelWebSite.Caption := WebSite else
      begin
        LabelWebSite.Caption := Copy(WebSite, I+3, Length(WebSite));
        LabelWebSite.URL := WebSite;
      end;
    end;
    ShowModal;
  finally
    Free;
  end;
end;

end.
